#include "Form1.frm"

#define SQLITE_OPEN_READONLY                                                   1
#define SQLITE_OPEN_READWRITE                                                  2
#define SQLITE_OPEN_CREATE                                                     4

#define SQLITE_OK                                                              0
#define SQLITE_ERROR                                                           1
#define SQLITE_CANTOPEN                                                       14
#define SQLITE_CONSTRAINT                                                     19
#define SQLITE_ROW                                                           100
#define SQLITE_DONE                                                          101

/*
 * Evento OnShow.
 */
method Form1OnShow( oSender ) class TForm1

   local cFileName, nDb
   
   cFileName := ExtractFilePath( Application:ExeName ) + "Test.db"

   if !File( cFileName )
      MessageDlg( "No se encontr la base de datos, se va a crear una nuava base de datos.", mtInformation, mbOk, poActiveCenter )

      if sqlite3_open_v2( cFileName, @nDb, SQLITE_OPEN_READWRITE + SQLITE_OPEN_CREATE ) != SQLITE_OK
         MessageDlg( "No se pudo crear la base de datos.", mtError, mbOk, poActiveCenter )
         Application:Terminate()

         return
      endif

      sqlite3_close_v2( nDb )
   endif

   ::FOrder := 1
   ::FGrid:Alignments := { taLeftJustify, taLeftJustify, taLeftJustify, taLeftJustify, taCenter, taRightJustify }
   ::FillData()

return

/*
 * Evento OnHeaderClick.
 */
method FGridOnHeaderClick( oSender, nCol ) class TForm1

   ::FOrder := nCol
   ::FillData()

return

/*
 * Carga los datos.
 */
method FillData() class TForm1

   local aItems, nDb, cFileName, cBuffer

   do case
      case ::FOrder == 1
         ::FGrid:HeaderImageList:Images := { "Order", "", "", "", "", "" }

      case ::FOrder == 2
         ::FGrid:HeaderImageList:Images := { "", "Order", "", "", "", "" }

      case ::FOrder == 3
         ::FGrid:HeaderImageList:Images := { "", "", "Order", "", "", "" }

      case ::FOrder == 4
         ::FGrid:HeaderImageList:Images := { "", "", "", "Order", "", "" }

      case ::FOrder == 5
         ::FGrid:HeaderImageList:Images := { "", "", "", "", "Order", "" }

      case ::FOrder == 6
         ::FGrid:HeaderImageList:Images := { "", "", "", "", "", "Order" }
   endcase

   aItems := {}
   cFileName := ExtractFilePath( Application:ExeName ) + "Test.db"

   if sqlite3_open_v2( cFileName, @nDb, SQLITE_OPEN_READWRITE ) == SQLITE_OK
      sqlite3_execute_query( nDb, "SELECT First, Last, Street, City, State, '', Salary FROM Tabla1", @cBuffer )
      sqlite3_expand_query( cBuffer,,, @aItems )
      sqlite3_close_v2( nDb )
   endif

   AEval( aItems, { | aItem | aItem[ 6 ] := LTrim( Transform( aItem[ 7 ], "@E 999,999,999,999.99" ) ) } )

   if ::FOrder == 6
      ASort( aItems,,, { | x, y | x[ 7 ] < y[ 7 ] } )
   else
      ASort( aItems,,, { | x, y | x[ ::FOrder ] < y[ ::FOrder ] } )
   endif
   
   ::FGrid:Items := aItems
   ::FGrid:Row := 1

return

